# Definition of the Anchors
.commonTags:
  tags: &commonTags
    - docker
    - gce

.only_tags:
  only: &only_tags
    - tags

.only_master:
  only: &only_master
    - master

stages: 
  - lint
  - build

before_script:
  - docker login -u "$DOCKERHUB_REGISTRY_USER" -p "$DOCKERHUB_REGISTRY_PASSWORD" 

# Check if the good practices have been applied with the Dockerfile
lint-job:
  image: projectatomic/dockerfile-lint:latest
  stage: lint
  tags: *commonTags
  only: *only_master
  before_script:
    - /usr/bin/dockerfile_lint -h
  script:
    - /usr/bin/dockerfile_lint -j -f Dockerfile

# Build, then push to gitlab registry
docker-build-master:
  # Official docker image.
  image: docker:latest
  stage: build
  tags: *commonTags
  only: *only_master
  services:
    - docker:dind
  script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
    # Build the image
    - docker build --pull -t "$CI_REGISTRY_IMAGE" .
    # Publish the image
    - docker push "$CI_REGISTRY_IMAGE"
    - 'echo Well done! Your image $CI_REGISTRY_IMAGE is published within gitlab.com registry.'

# Build, then push to official Docker hub when tag
docker-build-dockerhub:
  # Official docker image.
  image: docker:latest
  stage: build
  tags: *commonTags
  only:
    - tags
  services:
    - docker:dind
  script: 
    # Build the image
    - docker build --pull -t $CI_REGISTRY_IMAGE:$CI_BUILD_TAG .
    # Tag the image with the right tag
    - docker tag $CI_REGISTRY_IMAGE:$CI_BUILD_TAG $DOCKERHUB_REGISTRY_USER/$CI_PROJECT_NAME:$CI_BUILD_TAG
    # Publish the image
    - docker push $DOCKERHUB_REGISTRY_USER/$CI_PROJECT_NAME:$CI_BUILD_TAG
    # Print full image name
    - 'echo Well done! Your image is published and can be used by doing: docker pull $DOCKERHUB_REGISTRY_USER/$CI_PROJECT_NAME:$CI_BUILD_TAG.'

